/*<html><pre>*/
#ifndef V_GPSP_H
#define V_GPSP_H

/*
 *	General-purpose one-dimensional spline interpolation functions.
 */

#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	void_p	V_GLOBAL	cspCreate(vector_t *vx,vector_t *vy);
	mvec_t	V_GLOBAL	cspInterpolate(void_p csi,mvec_t x);
	void	V_GLOBAL	cspChangeX(void_p csp,vector_t *new_x);
	void	V_GLOBAL	cspChangeY(void_p csp,vector_t *new_y);
    /*		'cond':
     *		0: use 1st derivatives;
     *		1: use 2nd derivatives;
     *		2: for one period of periodical curve;
     *		3: ... (i can't explain shortly, sorry :)
     */
	void	V_GLOBAL	cspSetBoundaryCondition(void_p csp,
		u32_t cond,mvec_t cond_left,mvec_t cond_right);
	void	V_GLOBAL	cspDestroy(void_p csp);
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#endif	/* V_GPSP_H */
/*</pre></strong></body></html>*/
/*EOF*/
