#ifndef OSHEAD_H
#define OSHEAD_H

#if defined(__WIN32__)

/*
 * Win32 - specific system headers
 */

#ifdef	_MSC_VER
#pragma	warning(disable:4201)
#pragma	warning(disable:4214)
#pragma	warning(disable:4115)
#pragma	warning(disable:4514)
#pragma	warning(disable:4005)
#endif	/* _MSC_VER */

#ifdef	MAXCHAR
#undef	MAXCHAR
#endif	/* MAXCHAR */
#ifdef	MAXSHORT
#undef	MAXSHORT
#endif	/* MAXSHORT */

#ifndef	__CYGWIN32__
#ifdef	MAXLONG
#undef	MAXLONG
#endif	/* MAXLONG */
#endif	/* __CYGWIN32__ */

#ifdef	MUST_DIE_DEAD
#ifndef	_WIN32_WINNT
#define	_WIN32_WINNT	0x0400
#endif	/* !_WIN32_WINNT */
#endif	/* MUST_DIE_DEAD */

#include <windows.h>

#ifdef	__CYGWIN32__
#include <../source/PAL/win32/cygwin/mmreg.h>
#include <../source/PAL/win32/cygwin/mmsystem.h>
#include <unistd.h>
#include <errno.h>
#include <dirent.h>
#include <io.h>
#include <sys/fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/mman.h>
#else	/* !__CYGWIN32__ */
#include <mmsystem.h>
#include <io.h>
#include <sys/stat.h>
#include <direct.h>
#endif	/* !__CYGWIN32__ */

#ifdef	_MSC_VER
#pragma	warning(default:4201)
#pragma	warning(default:4214)
#pragma	warning(default:4115)
#pragma warning(default:4005)
#endif	/* _MSC_VER */

#if		defined(_MSC_VER) || defined(__BORLANDC__) || defined(__WATCOMC__)
#pragma	hdrstop
#endif

#elif defined(__UNIX__) /* !__WIN32__ */

#ifdef		__linux
#define		__USE_UNIX98
#endif		/* __linux */

/*
 *	09.11.2001 - Mandrake 8 - eto pornografiya. I can't #include
 *	pthread.h otherwise as first !!! DAMN.
 *	While compiling PTHREAD-aware parts (shed.c, in particular),
 *	gcc will warn about implicit declarations; ignore it.
 */
#ifdef	__linux
#define	__USE_UNIX98
#endif	/* __linux */

#include <pthread.h>
#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>
#include <signal.h>
#include <errno.h>
#include <time.h>
#include <sys/time.h>
#include <dlfcn.h>
#include <sys/io.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/mman.h>

#ifdef	__linux
#include <linux/soundcard.h>
#elif	defined(__bsdi__) /* !__linux */
#include <sys/soundcard.h>
#else	/* !__bsdi__ */
#include <machine/soundcard.h>
#endif	/* !__bsdi__ */

#endif		/* defined(__UNIX__) */

#endif		/* OSHEAD_H */
