# =========================================================================
# Unix - specific defines.
# Note: before include this file, you must define 'libvroot' - path
# to libV root directory.
# =========================================================================
cc=gcc
ld=gcc
rm=rm -f
suffix=a
cdebug=-ggdb
ccflags=-O2 -c -Wall -pedantic -fomit-frame-pointer -rdynamic \
	-idirafter $(libvroot)/include
ldflags=
libv=$(libvroot)/arch/unix/libv.$(suffix)
sys_libpath=/usr/lib
x11_libpath=/usr/X11R6/lib
rtl_libs= \
	$(sys_libpath)/libpthread.so \
	$(sys_libpath)/libm.so \
	$(sys_libpath)/libdl.so
x11_libs= \
	$(x11_libpath)/libX11.so \
	$(x11_libpath)/libGL.so \
	$(x11_libpath)/libXext.so \
	$(x11_libpath)/libXxf86vm.a
