/*<html><pre>*/
#ifndef V_PARSE_H
#define V_PARSE_H

#ifdef  __cplusplus
extern  "C" {
#endif	/* __cplusplus */
	/* Returns malloc()'ed block, buffer NOT copied into block */
    object_handle_t V_GLOBAL	tokParseString(char *buffer,char *delim);
	/* Returns malloc()'ed block, with entire file copied into it */
    object_handle_t V_GLOBAL	tokParseFile(char *filename,char *delim);
	/* Resets position to start, optionally (if args != NULL) 
	 * sets new source and delimiters. */
    void		V_GLOBAL	tokRestart(object_handle_t tok,
    	char *new_buffer,char *new_delim);
	/* Saving/restoring scanner cursor position */
    vboolean	V_GLOBAL	tokPush(object_handle_t tok);
    vboolean	V_GLOBAL	tokPop(object_handle_t tok);
	/*	Returns either string inside 'buffer' (if created  with
	 *	tokStart()), or string inside 'tok' (if created  with
	 *	tokStartFile()).
	 */
    char_p		V_GLOBAL	tokNext(object_handle_t tok);
	/*
	 *	Same as tokNext(), whitespace and quotes handled as usual chars.
	 */
    char_p		V_GLOBAL	tokStrict(object_handle_t tok);
    /*	Returns next string (i.e. sequence ended with EOL);
	 *	EOL itself NOT stored in result.
	 */
	char_p		V_GLOBAL	tokString(object_handle_t tok);
    /*
	 *	Returns last result of tok[Next | Strict | String], or
     *	NULL if:
     *		- was no previous call to mentioned functions;
     *		- no more chars (or something else wrong).
	 */
	char_p		V_GLOBAL	tokLast(object_handle_t tok);
	/*	Destroys scanner */
	void		V_GLOBAL	tokDestroy(object_handle_t tok);
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* V_PARSE_H */
/*</pre></strong></body></html>*/
/*EOF*/
