/*M*
//
//               INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//        Copyright (c) 1995 Intel Corporation. All Rights Reserved.
//
//  RCS:
//      $Source: d:/rcs/nsp20/include/nspcnv2d.h $
//      $Revision: 1.3 $
//      $Date: 1995/08/07 10:57:04 $
//
//  Purpose: NSP 2D Filtering Functions
*M*/

#if !defined _NSPCONV2D_H || defined _NSP_BLDPCS
# define _NSPCONV2D_H

/*
 * Conv2D
 *
 * Perform finite, linear convolution of two two-dimensional signals.
*/

NSPAPI(void,nspsConv2D,(const float  *x, int xCols, int xRows,
                        const float  *h, int hCols, int hRows, float *y));
NSPAPI(void,nspdConv2D,(const double *x, int xCols, int xRows,
                        const double *h, int hCols, int hRows, double *y));

#endif
